# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

class VipMediaSettings(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        VipMediaSettings - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'enabled': 'bool',
            'skip_ownership_time': 'bool'
        }

        self.attribute_map = {
            'enabled': 'enabled',
            'skip_ownership_time': 'skipOwnershipTime'
        }

        self._enabled = None
        self._skip_ownership_time = None

    @property
    def enabled(self):
        """
        Gets the enabled of this VipMediaSettings.
        Toggle that enables VIP experience for this feature.

        :return: The enabled of this VipMediaSettings.
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """
        Sets the enabled of this VipMediaSettings.
        Toggle that enables VIP experience for this feature.

        :param enabled: The enabled of this VipMediaSettings.
        :type: bool
        """
        

        self._enabled = enabled

    @property
    def skip_ownership_time(self):
        """
        Gets the skip_ownership_time of this VipMediaSettings.
        Toggle that enables this media type to fallback immediately to the configured VIP Backup.

        :return: The skip_ownership_time of this VipMediaSettings.
        :rtype: bool
        """
        return self._skip_ownership_time

    @skip_ownership_time.setter
    def skip_ownership_time(self, skip_ownership_time):
        """
        Sets the skip_ownership_time of this VipMediaSettings.
        Toggle that enables this media type to fallback immediately to the configured VIP Backup.

        :param skip_ownership_time: The skip_ownership_time of this VipMediaSettings.
        :type: bool
        """
        

        self._skip_ownership_time = skip_ownership_time

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

